<!DOCTYPE html>
<html>

<head>
  <title></title>
  <style>
    html,
    body {
      height: 100%;
      margin: 0;
      overflow: hidden;
    }

    main {
      background: black;
      display: flex;
      align-items: center;
      justify-content: center;
      height: 100%;
    }

    canvas {
      border: 1px solid white;
    }
  </style>
</head>

<body>


</body>

</html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />

  <link rel="stylesheet" href="/css/style.css" />
  <link href="https://fonts.googleapis.com/css?family=Open+Sans:300,400,700&display=swap" rel="stylesheet" />
</head>

<body>
  <nav class="navbar">
    <ul class="navbar-nav">
      <li class="logo">
        <a href="#" class="nav-link">
          <span class="link-text logo-text">Game site</span>
          <svg aria-hidden="true" focusable="false" data-prefix="fad" data-icon="angle-double-right" role="img"
            xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"
            class="svg-inline--fa fa-angle-double-right fa-w-14 fa-5x">
            <g class="fa-group">
              <path fill="currentColor"
                d="M224 273L88.37 409a23.78 23.78 0 0 1-33.8 0L32 386.36a23.94 23.94 0 0 1 0-33.89l96.13-96.37L32 159.73a23.94 23.94 0 0 1 0-33.89l22.44-22.79a23.78 23.78 0 0 1 33.8 0L223.88 239a23.94 23.94 0 0 1 .1 34z"
                class="fa-secondary"></path>
              <path fill="currentColor"
                d="M415.89 273L280.34 409a23.77 23.77 0 0 1-33.79 0L224 386.26a23.94 23.94 0 0 1 0-33.89L320.11 256l-96-96.47a23.94 23.94 0 0 1 0-33.89l22.52-22.59a23.77 23.77 0 0 1 33.79 0L416 239a24 24 0 0 1-.11 34z"
                class="fa-primary"></path>
            </g>
          </svg>
        </a>
      </li>

      <li class="nav-item">
        <a href="../index.html" class="nav-link">
          <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="50pt" height="50pt"
            viewBox="0 0 50 50" version="1.1">
            <g id="surface3248324">
              <path style=" stroke:none;fill-rule:nonzero;fill:rgb(80.000001%,80.000001%,80.000001%);fill-opacity:1;"
                d="M 25 1.050781 C 24.78125 1.050781 24.566406 1.121094 24.378906 1.257812 L 1.378906 19.210938 C 0.949219 19.550781 0.871094 20.179688 1.210938 20.621094 C 1.550781 21.050781 2.179688 21.128906 2.617188 20.789062 L 4 19.710938 L 4 46 C 4 46.550781 4.449219 47 5 47 L 19 47 L 19 29 L 31 29 L 31 47 L 45 47 C 45.550781 47 46 46.550781 46 46 L 46 19.710938 L 47.378906 20.789062 C 47.570312 20.929688 47.78125 21 48 21 C 48.300781 21 48.589844 20.871094 48.789062 20.621094 C 49.128906 20.179688 49.050781 19.550781 48.617188 19.210938 L 25.617188 1.257812 C 25.433594 1.121094 25.21875 1.050781 25 1.050781 Z M 35 5 L 35 6.050781 L 41 10.730469 L 41 5 Z M 35 5 " />
            </g>
          </svg>
          <span class="link-text">Home</span>
        </a>
      </li>

      <li class="nav-item">
        <a href="#" class="nav-link">
          <svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"
            x="50px" y="50px" viewBox="0 0 512 512" style="enable-background:new 0 0 512 512;" xml:space="preserve">
            <rect x="16.568" y="367.165" style="fill:#F9D84E;" width="68.409" height="68.409" />
            <g>
              <rect x="16.568" y="418.472" style="fill:#FFC20D;" width="68.409" height="17.102" />
              <rect x="16.568" y="367.165" style="fill:#FFC20D;" width="17.102" height="68.409" />
            </g>
            <rect x="84.977" y="367.165" style="fill:#F9D84E;" width="68.409" height="68.409" />
            <g>
              <rect x="84.977" y="418.472" style="fill:#FFC20D;" width="68.409" height="17.102" />
              <rect x="84.977" y="367.165" style="fill:#FFC20D;" width="17.102" height="68.409" />
            </g>
            <rect x="84.977" y="298.756" style="fill:#F9D84E;" width="68.409" height="68.409" />
            <g>
              <rect x="84.977" y="350.063" style="fill:#FFC20D;" width="68.409" height="17.102" />
              <rect x="84.977" y="298.756" style="fill:#FFC20D;" width="17.102" height="68.409" />
            </g>
            <rect x="16.568" y="298.756" style="fill:#F9D84E;" width="68.409" height="68.409" />
            <g>
              <rect x="16.568" y="350.063" style="fill:#FFC20D;" width="68.409" height="17.102" />
              <rect x="16.568" y="298.756" style="fill:#FFC20D;" width="17.102" height="68.409" />
            </g>
            <rect x="16.568" y="435.574" style="fill:#B169BF;" width="68.409" height="68.409" />
            <g>
              <rect x="16.568" y="435.574" style="fill:#844A8F;" width="17.102" height="68.409" />
              <rect x="16.568" y="486.881" style="fill:#844A8F;" width="68.409" height="17.102" />
              <rect x="16.568" y="486.881" style="fill:#844A8F;" width="17.102" height="17.102" />
            </g>
            <rect x="84.977" y="435.574" style="fill:#B169BF;" width="68.409" height="68.409" />
            <g>
              <rect x="84.977" y="435.574" style="fill:#844A8F;" width="17.102" height="68.409" />
              <rect x="84.977" y="486.881" style="fill:#844A8F;" width="68.409" height="17.102" />
              <rect x="84.977" y="486.881" style="fill:#844A8F;" width="17.102" height="17.102" />
            </g>
            <rect x="153.386" y="435.574" style="fill:#B169BF;" width="68.409" height="68.409" />
            <g>
              <rect x="153.386" y="435.574" style="fill:#844A8F;" width="17.102" height="68.409" />
              <rect x="153.386" y="486.881" style="fill:#844A8F;" width="68.409" height="17.102" />
              <rect x="153.386" y="486.881" style="fill:#844A8F;" width="17.102" height="17.102" />
            </g>
            <rect x="221.795" y="435.574" style="fill:#B169BF;" width="68.409" height="68.409" />
            <g>
              <rect x="221.795" y="435.574" style="fill:#844A8F;" width="17.102" height="68.409" />
              <rect x="221.795" y="486.881" style="fill:#844A8F;" width="68.409" height="17.102" />
              <rect x="221.795" y="486.881" style="fill:#844A8F;" width="17.102" height="17.102" />
            </g>
            <rect x="221.795" y="367.165" style="fill:#FD5E95;" width="68.409" height="68.409" />
            <g>
              <rect x="221.795" y="418.472" style="fill:#D14D7B;" width="68.409" height="17.102" />
              <rect x="221.795" y="367.165" style="fill:#D14D7B;" width="17.102" height="68.409" />
            </g>
            <rect x="290.205" y="367.165" style="fill:#FD5E95;" width="68.409" height="68.409" />
            <g>
              <rect x="290.205" y="418.472" style="fill:#D14D7B;" width="68.409" height="17.102" />
              <rect x="290.205" y="367.165" style="fill:#D14D7B;" width="17.102" height="68.409" />
            </g>
            <rect x="290.205" y="435.574" style="fill:#FD5E95;" width="68.409" height="68.409" />
            <g>
              <rect x="290.205" y="486.881" style="fill:#D14D7B;" width="68.409" height="17.102" />
              <rect x="290.205" y="435.574" style="fill:#D14D7B;" width="17.102" height="68.409" />
            </g>
            <rect x="358.614" y="435.574" style="fill:#FD5E95;" width="68.409" height="68.409" />
            <g>
              <rect x="358.614" y="486.881" style="fill:#D14D7B;" width="68.409" height="17.102" />
              <rect x="358.614" y="435.574" style="fill:#D14D7B;" width="17.102" height="68.409" />
            </g>
            <rect x="256" y="8.017" style="fill:#FD5E95;" width="68.409" height="68.409" />
            <g>
              <rect x="256" y="59.324" style="fill:#D14D7B;" width="68.409" height="17.102" />
              <rect x="256" y="8.017" style="fill:#D14D7B;" width="17.102" height="68.409" />
            </g>
            <rect x="324.409" y="8.017" style="fill:#FD5E95;" width="68.409" height="68.409" />
            <g>
              <rect x="324.409" y="59.324" style="fill:#D14D7B;" width="68.409" height="17.102" />
              <rect x="324.409" y="8.017" style="fill:#D14D7B;" width="17.102" height="68.409" />
            </g>
            <rect x="324.409" y="76.426" style="fill:#FD5E95;" width="68.409" height="68.409" />
            <g>
              <rect x="324.409" y="127.733" style="fill:#D14D7B;" width="68.409" height="17.102" />
              <rect x="324.409" y="76.426" style="fill:#D14D7B;" width="17.102" height="68.409" />
            </g>
            <rect x="392.818" y="76.426" style="fill:#FD5E95;" width="68.409" height="68.409" />
            <g>
              <rect x="392.818" y="127.733" style="fill:#D14D7B;" width="68.409" height="17.102" />
              <rect x="392.818" y="76.426" style="fill:#D14D7B;" width="17.102" height="68.409" />
            </g>
            <rect x="358.614" y="367.165" style="fill:#7DBB34;" width="68.409" height="68.409" />
            <g>
              <rect x="358.614" y="418.472" style="fill:#60A333;" width="68.409" height="17.102" />
              <rect x="358.614" y="367.165" style="fill:#60A333;" width="17.102" height="68.409" />
            </g>
            <rect x="427.023" y="367.165" style="fill:#7DBB34;" width="68.409" height="68.409" />
            <g>
              <rect x="427.023" y="418.472" style="fill:#60A333;" width="68.409" height="17.102" />
              <rect x="427.023" y="367.165" style="fill:#60A333;" width="17.102" height="68.409" />
            </g>
            <rect x="427.023" y="435.574" style="fill:#7DBB34;" width="68.409" height="68.409" />
            <g>
              <rect x="427.023" y="486.881" style="fill:#60A333;" width="68.409" height="17.102" />
              <rect x="427.023" y="435.574" style="fill:#60A333;" width="17.102" height="68.409" />
            </g>
            <rect x="358.614" y="298.756" style="fill:#7DBB34;" width="68.409" height="68.409" />
            <g>
              <rect x="358.614" y="350.063" style="fill:#60A333;" width="68.409" height="17.102" />
              <rect x="358.614" y="298.756" style="fill:#60A333;" width="17.102" height="68.409" />
            </g>
            <rect x="153.386" y="127.733" style="fill:#45CAE0;" width="68.409" height="68.409" />
            <g>
              <rect x="153.386" y="179.04" style="fill:#0AADBF;" width="68.409" height="17.102" />
              <rect x="153.386" y="127.733" style="fill:#0AADBF;" width="17.102" height="68.409" />
            </g>
            <rect x="153.386" y="196.142" style="fill:#45CAE0;" width="68.409" height="68.409" />
            <g>
              <rect x="153.386" y="247.449" style="fill:#0AADBF;" width="68.409" height="17.102" />
              <rect x="153.386" y="196.142" style="fill:#0AADBF;" width="17.102" height="68.409" />
            </g>
            <rect x="221.795" y="196.142" style="fill:#45CAE0;" width="68.409" height="68.409" />
            <g>
              <rect x="221.795" y="247.449" style="fill:#0AADBF;" width="68.409" height="17.102" />
              <rect x="221.795" y="196.142" style="fill:#0AADBF;" width="17.102" height="68.409" />
            </g>
            <rect x="153.386" y="264.551" style="fill:#45CAE0;" width="68.409" height="68.409" />
            <g>
              <rect x="153.386" y="315.858" style="fill:#0AADBF;" width="68.409" height="17.102" />
              <rect x="153.386" y="264.551" style="fill:#0AADBF;" width="17.102" height="68.409" />
            </g>
            <path d="M256,84.443h60.392v60.392c0,4.428,3.588,8.017,8.017,8.017h136.818c4.428,0,8.017-3.588,8.017-8.017V76.426
	c0-4.428-3.588-8.017-8.017-8.017h-60.392V8.017c0-4.428-3.588-8.017-8.017-8.017H256c-4.427,0-8.017,3.588-8.017,8.017v68.409
	C247.983,80.854,251.573,84.443,256,84.443z M332.426,84.443h52.376v52.376h-52.376V84.443z M453.211,136.818h-52.376V84.443h52.376
	V136.818z M384.802,68.409h-52.376V16.033h52.376V68.409z M264.017,16.033h52.376v52.376h-52.376V16.033z" />
            <path d="M495.432,359.148H435.04v-60.392c0-4.428-3.588-8.017-8.017-8.017h-68.409c-4.428,0-8.017,3.588-8.017,8.017v60.392h-9.086
	c-4.428,0-8.017,3.588-8.017,8.017c0,4.428,3.588,8.017,8.017,8.017h9.086v52.376h-52.376v-52.376h9.086
	c4.428,0,8.017-3.588,8.017-8.017c0-4.428-3.588-8.017-8.017-8.017h-85.511c-4.427,0-8.017,3.588-8.017,8.017v60.392h-52.376v-86.58
	h60.392c4.427,0,8.017-3.588,8.017-8.017v-60.392h60.392c4.428,0,8.017-3.588,8.017-8.017v-68.409c0-4.428-3.588-8.017-8.017-8.017
	h-60.392v-60.392c0-4.428-3.589-8.017-8.017-8.017h-68.409c-4.427,0-8.017,3.588-8.017,8.017v17.102
	c0,4.428,3.589,8.017,8.017,8.017c4.427,0,8.017-3.588,8.017-8.017v-9.086h52.376v52.376h-52.376v-9.086
	c0-4.428-3.589-8.017-8.017-8.017c-4.427,0-8.017,3.588-8.017,8.017v111.699H67.875c-4.427,0-8.017,3.588-8.017,8.017
	s3.589,8.017,8.017,8.017h9.086v52.376H24.585v-52.376h9.086c4.427,0,8.017-3.588,8.017-8.017s-3.589-8.017-8.017-8.017H16.568
	c-4.427,0-8.017,3.588-8.017,8.017v205.228c0,4.428,3.589,8.017,8.017,8.017h478.864c4.428,0,8.017-3.588,8.017-8.017V367.165
	C503.449,362.737,499.861,359.148,495.432,359.148z M487.415,427.557H435.04v-52.376h52.376V427.557z M366.63,375.182h52.376v52.376
	H366.63V375.182z M366.63,306.772h52.376v52.376H366.63V306.772z M229.812,375.182h52.376v52.376h-52.376V375.182z M92.994,375.182
	h52.376v52.376H92.994V375.182z M213.779,324.944h-52.376v-52.376h52.376V324.944z M282.188,256.534h-52.376v-52.376h52.376V256.534
	z M213.779,204.159v52.376h-52.376v-52.376H213.779z M145.37,359.148H92.994v-52.376h52.376V359.148z M76.96,375.182v52.376H24.585
	v-52.376H76.96z M24.585,443.591H76.96v52.376H24.585V443.591z M92.994,443.591h52.376v52.376H92.994V443.591z M161.403,443.591
	h52.376v52.376h-52.376V443.591z M229.812,443.591h52.376v52.376h-52.376V443.591z M298.221,443.591h52.376v52.376h-52.376V443.591z
	 M366.63,443.591h52.376v52.376H366.63V443.591z M487.415,495.967H435.04v-52.376h52.376V495.967z" />
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
          </svg>
          <span class="link-text">Tetris</span>
        </a>
      </li>

      <li class="nav-item">
        <a href="/games/snake.html" class="nav-link">
          <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" id="Capa_1"
            x="0px" y="0px" viewBox="0 0 512 512" style="enable-background:new 0 0 512 512;" xml:space="preserve">
            <path style="fill:#EB4F00;"
              d="M166,30H71.164c-2.529-9.366-7.218-18.27-14.559-25.605c-5.859-5.859-15.352-5.859-21.211,0  s-5.859,15.352,0,21.211c10.693,10.693,10.693,28.096,0,38.789c-5.859,5.859-5.859,15.352,0,21.211C38.324,88.535,42.162,90,46,90  s7.676-1.465,10.605-4.395C63.946,78.27,68.635,69.366,71.164,60H166c8.291,0,15-6.709,15-15S174.291,30,166,30z" />
            <path style="fill:#32D736;"
              d="M286,60v212h-90V90h-15c-24.901,0-45-20.099-45-45s20.099-45,45-45h45c5.099,0,10.201,0.601,15,2.1  C266.8,8.699,286,32.1,286,60z" />
            <path style="fill:#10BB67;" d="M286,60v212h-45V2.1C266.8,8.699,286,32.1,286,60z" />
            <path style="fill:#32D736;"
              d="M452,377c0,24.901-20.099,45-45,45H106c-24.901,0-45-20.099-45-45s20.099-45,45-45h301  C431.901,332,452,352.099,452,377z" />
            <path style="fill:#10BB67;"
              d="M512,416.3v5.7c0,49.799-40.201,90-90,90H45c-24.901,0-45-20.099-45-45s20.099-45,45-45h385.699  c14.101,0,27.9-3.3,40.201-9.6l19.501-9.6C500.3,398,512,405.2,512,416.3z" />
            <path style="fill:#0CA656;"
              d="M512,416.3v5.7c0,49.799-40.201,90-90,90H241v-90h189.699c14.101,0,27.9-3.3,40.201-9.6l19.501-9.6  C500.3,398,512,405.2,512,416.3z" />
            <g>
              <path style="fill:#10BB67;"
                d="M452,377c0,24.901-20.099,45-45,45H241v-90h166C431.901,332,452,352.099,452,377z" />
              <path style="fill:#10BB67;"
                d="M392,287c0,24.901-20.099,45-45,45H166c-24.901,0-45-20.099-45-45s20.099-45,45-45h181   C371.901,242,392,262.099,392,287z" />
            </g>
            <path style="fill:#0CA656;" d="M347,332H241v-90h106c24.901,0,45,20.099,45,45S371.901,332,347,332z" />
            <path style="fill:#664B34;" d="M181,0v30c0,8.291,6.709,15,15,15s15-6.709,15-15V0H181z" />
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
          </svg>
          <span class="link-text">Snake</span>
        </a>
      </li>

      <li class="nav-item">
        <a href="/games/pong.html" class="nav-link">
          <svg version="1.1" id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"
            x="0px" y="0px" viewBox="0 0 512 512" style="enable-background:new 0 0 512 512;" xml:space="preserve">
            <path style="fill:#F44D4D;" d="M418.566,382.61c-27.481,27.47-60.044,45.977-93.335,55.183
	c-42.761,11.81-86.723,8.257-122.651-11.431h-0.01l-74.29,74.29c-1.898,1.898-3.933,3.544-6.085,4.967
	c-6.443,4.26-13.877,6.38-21.311,6.38c-9.912,0-19.835-3.775-27.407-11.347c-15.133-15.132-15.133-39.67,0-54.803l13.171-13.171
	l61.12-61.12c-19.793-36.117-23.273-80.365-11.231-123.347c9.258-33.049,27.702-65.359,54.993-92.64
	c53.39-53.401,126.004-72.962,185.837-56.047c22.988,6.485,44.089,18.359,61.488,35.758
	C501.546,197.976,492.466,308.7,418.566,382.61z" />
            <path style="fill:#DB3B3B;" d="M377.134,268.859c-15.986,36.107-40.197,65.464-68.523,86.09
	c-29.853,21.745-64.262,33.786-98.386,33.786c-6.286,0-12.57-0.411-18.813-1.244l-39.755,74.085l-2.784,6.285
	c-5.125,11.578-15.227,19.392-26.679,22.061c-2.858,0.664-5.811,1.012-8.784,1.012c-5.231,0-10.556,14.631-15.66,12.374
	c-19.571-8.668-28.409-31.562-19.741-51.123l8.637-19.509l61.12-61.12c-19.793-36.117-23.273-80.365-11.231-123.347
	c9.258-33.049,27.702-65.359,54.993-92.64c53.39-53.401,126.004-72.962,185.837-56.047
	C401.304,147.559,403.065,210.282,377.134,268.859z" />
            <path style="fill:#E29F33;" d="M325.232,437.793c-42.761,11.81-86.723,8.257-122.651-11.431h-0.01l-74.29,74.29
	C120.709,508.224,110.796,512,100.884,512s-19.835-3.775-27.407-11.347c-15.133-15.132-15.133-39.67,0-54.803l74.29-74.29
	c-19.793-36.117-23.273-80.365-11.231-123.347l188.611,188.62L325.232,437.793z" />
            <path style="fill:#55B5E0;" d="M343.887,249.883c-15.989,36.1-40.202,65.461-68.527,86.085
	c-29.853,21.744-64.258,33.787-98.38,33.787c-6.289,0-12.567-0.408-18.814-1.245l-42.535,96.068
	c-6.404,14.471-20.593,23.073-35.472,23.073c-5.221,0-10.547-1.067-15.654-3.317c-19.578-8.674-28.409-31.569-19.745-51.126
	l42.546-96.068l-0.01-0.01c-31.485-26.567-50.676-66.57-54.914-110.999v-0.01c-2.323-24.182-0.209-49.671,6.77-75.015
	c2.867-10.464,6.582-20.907,11.144-31.213C61.774,93.973,77.49,71.518,95.938,53.29c49.535-49.002,118.68-67.596,177.768-41.436
	C354.779,47.744,386.191,154.318,343.887,249.883z" />
            <path style="fill:#FCE381;"
              d="M276.281,334.123l-0.918,1.846c-29.853,21.745-64.262,33.786-98.386,33.786
	c-6.285,0-12.57-0.411-18.813-1.244l-42.539,96.066c-6.401,14.468-20.584,23.074-35.464,23.074c-5.231,0-10.556-1.065-15.66-3.322
	c-19.571-8.668-28.409-31.562-19.741-51.123L87.3,337.14l-0.01-0.01c-31.476-26.564-50.669-66.572-54.907-110.998L276.281,334.123z" />
            <path style="fill:#188EB7;"
              d="M149,113.959c0,33.798-27.405,61.202-61.213,61.202c-19.829,0-37.46-9.438-48.635-24.056
	c2.867-10.464,6.582-20.907,11.144-31.213C61.774,93.973,77.49,71.518,95.938,53.29C125.896,57.267,149,82.912,149,113.959z" />
            <circle style="fill:#DEDEDE;" cx="108.718" cy="108.728" r="61.213" />
            <path style="fill:#F0F0F0;" d="M169.927,108.727c0,27.802-18.552,51.283-43.948,58.733c-25.395-7.45-43.948-30.931-43.948-58.733
	c0-27.813,18.552-51.293,43.948-58.743C151.375,57.434,169.927,80.915,169.927,108.727z" />
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
            <g>
            </g>
          </svg>

          <span class="link-text">Pong</span>
        </a>
      </li>

      <li class="nav-item">
        <a href="../info.html" class="nav-link">
          <svg id="Layer_1" enable-background="new 0 0 511.979 511.979" height="512" viewBox="0 0 511.979 511.979"
            width="512" xmlns="http://www.w3.org/2000/svg">
            <g>
              <path
                d="m437.002 74.978c-48.351-48.351-112.635-74.978-181.012-74.978s-132.662 26.627-181.012 74.978c-48.351 48.35-74.978 112.634-74.978 181.012s26.627 132.662 74.978 181.012 112.635 74.978 181.012 74.978 132.662-26.627 181.012-74.978 74.978-112.635 74.978-181.012-26.628-132.662-74.978-181.012z"
                fill="#ffcd70" />
              <path
                d="m307.007 379.473v-171.034h-84.869-15-39.323v30h39.323v141.034h-39.323v30h39.323 99.869 39.323v-30z"
                fill="#0078a8" />
              <path d="m207.138 84.248h99.869v99.869h-99.869z" fill="#0078a8" />
              <path
                d="m437.002 74.978c-48.351-48.351-112.635-74.978-181.012-74.978v511.979c68.377 0 132.662-26.627 181.012-74.978s74.978-112.635 74.978-181.012-26.628-132.661-74.978-181.011z"
                fill="#ffac63" />
              <g fill="#005f90">
                <path d="m255.99 84.248h51.017v99.869h-51.017z" />
                <path d="m307.007 379.473v-171.034h-51.017v201.034h51.017 39.323v-30z" />
              </g>
            </g>
          </svg>
          <span class="link-text">Info</span>
        </a>
      </li>
    </ul>
  </nav>

  <main>

    <canvas width="320" height="640" id="game"></canvas>

  </main>
  <script defer src="js/theme.js"></script>
  <script>
    window.onload = function () {
      alert("Press OK to start the game")
    };

    // https://tetris.fandom.com/wiki/Tetris_Guideline

    // get a random integer between the range of [min,max]
    // @see https://stackoverflow.com/a/1527820/2124254
    function getRandomInt(min, max) {
      min = Math.ceil(min);
      max = Math.floor(max);

      return Math.floor(Math.random() * (max - min + 1)) + min;
    }

    // generate a new tetromino sequence
    // @see https://tetris.fandom.com/wiki/Random_Generator
    function generateSequence() {
      const sequence = ['I', 'J', 'L', 'O', 'S', 'T', 'Z'];

      while (sequence.length) {
        const rand = getRandomInt(0, sequence.length - 1);
        const name = sequence.splice(rand, 1)[0];
        tetrominoSequence.push(name);
      }
    }

    // get the next tetromino in the sequence
    function getNextTetromino() {
      if (tetrominoSequence.length === 0) {
        generateSequence();
      }

      const name = tetrominoSequence.pop();
      const matrix = tetrominos[name];

      // I and O start centered, all others start in left-middle
      const col = playfield[0].length / 2 - Math.ceil(matrix[0].length / 2);

      // I starts on row 21 (-1), all others start on row 22 (-2)
      const row = name === 'I' ? -1 : -2;

      return {
        name: name,      // name of the piece (L, O, etc.)
        matrix: matrix,  // the current rotation matrix
        row: row,        // current row (starts offscreen)
        col: col         // current col
      };
    }

    // rotate an NxN matrix 90deg
    // @see https://codereview.stackexchange.com/a/186834
    function rotate(matrix) {
      const N = matrix.length - 1;
      const result = matrix.map((row, i) =>
        row.map((val, j) => matrix[N - j][i])
      );

      return result;
    }

    // check to see if the new matrix/row/col is valid
    function isValidMove(matrix, cellRow, cellCol) {
      for (let row = 0; row < matrix.length; row++) {
        for (let col = 0; col < matrix[row].length; col++) {
          if (matrix[row][col] && (
            // outside the game bounds
            cellCol + col < 0 ||
            cellCol + col >= playfield[0].length ||
            cellRow + row >= playfield.length ||
            // collides with another piece
            playfield[cellRow + row][cellCol + col])
          ) {
            return false;
          }
        }
      }

      return true;
    }

    // place the tetromino on the playfield
    function placeTetromino() {
      for (let row = 0; row < tetromino.matrix.length; row++) {
        for (let col = 0; col < tetromino.matrix[row].length; col++) {
          if (tetromino.matrix[row][col]) {

            // game over if piece has any part offscreen
            if (tetromino.row + row < 0) {
              return showGameOver();
            }

            playfield[tetromino.row + row][tetromino.col + col] = tetromino.name;
          }
        }
      }

      // check for line clears starting from the bottom and working our way up
      for (let row = playfield.length - 1; row >= 0;) {
        if (playfield[row].every(cell => !!cell)) {

          // drop every row above this one
          for (let r = row; r >= 0; r--) {
            for (let c = 0; c < playfield[r].length; c++) {
              playfield[r][c] = playfield[r - 1][c];
            }
          }
        }
        else {
          row--;
        }
      }

      tetromino = getNextTetromino();
    }

    // show the game over screen
    function showGameOver() {
      cancelAnimationFrame(rAF);
      gameOver = true;

      context.fillStyle = 'black';
      context.globalAlpha = 0.75;
      context.fillRect(0, canvas.height / 2 - 30, canvas.width, 60);

      context.globalAlpha = 1;
      context.fillStyle = 'white';
      context.font = '36px monospace';
      context.textAlign = 'center';
      context.textBaseline = 'middle';
      context.fillText('GAME OVER!', canvas.width / 2, canvas.height / 2);
    }

    const canvas = document.getElementById('game');
    const context = canvas.getContext('2d');
    const grid = 32;
    const tetrominoSequence = [];

    // keep track of what is in every cell of the game using a 2d array
    // tetris playfield is 10x20, with a few rows offscreen
    const playfield = [];

    // populate the empty state
    for (let row = -2; row < 20; row++) {
      playfield[row] = [];

      for (let col = 0; col < 10; col++) {
        playfield[row][col] = 0;
      }
    }

    // how to draw each tetromino
    // @see https://tetris.fandom.com/wiki/SRS
    const tetrominos = {
      'I': [
        [0, 0, 0, 0],
        [1, 1, 1, 1],
        [0, 0, 0, 0],
        [0, 0, 0, 0]
      ],
      'J': [
        [1, 0, 0],
        [1, 1, 1],
        [0, 0, 0],
      ],
      'L': [
        [0, 0, 1],
        [1, 1, 1],
        [0, 0, 0],
      ],
      'O': [
        [1, 1],
        [1, 1],
      ],
      'S': [
        [0, 1, 1],
        [1, 1, 0],
        [0, 0, 0],
      ],
      'Z': [
        [1, 1, 0],
        [0, 1, 1],
        [0, 0, 0],
      ],
      'T': [
        [0, 1, 0],
        [1, 1, 1],
        [0, 0, 0],
      ]
    };

    // color of each tetromino
    const colors = {
      'I': 'cyan',
      'O': 'yellow',
      'T': 'purple',
      'S': 'green',
      'Z': 'red',
      'J': 'blue',
      'L': 'orange'
    };

    let count = 0;
    let tetromino = getNextTetromino();
    let rAF = null;  // keep track of the animation frame so we can cancel it
    let gameOver = false;

    // game loop
    function loop() {
      rAF = requestAnimationFrame(loop);
      context.clearRect(0, 0, canvas.width, canvas.height);

      // draw the playfield
      for (let row = 0; row < 20; row++) {
        for (let col = 0; col < 10; col++) {
          if (playfield[row][col]) {
            const name = playfield[row][col];
            context.fillStyle = colors[name];

            // drawing 1 px smaller than the grid creates a grid effect
            context.fillRect(col * grid, row * grid, grid - 1, grid - 1);
          }
        }
      }

      // draw the active tetromino
      if (tetromino) {

        // tetromino falls every 35 frames
        if (++count > 35) {
          tetromino.row++;
          count = 0;

          // place piece if it runs into anything
          if (!isValidMove(tetromino.matrix, tetromino.row, tetromino.col)) {
            tetromino.row--;
            placeTetromino();
          }
        }

        context.fillStyle = colors[tetromino.name];

        for (let row = 0; row < tetromino.matrix.length; row++) {
          for (let col = 0; col < tetromino.matrix[row].length; col++) {
            if (tetromino.matrix[row][col]) {

              // drawing 1 px smaller than the grid creates a grid effect
              context.fillRect((tetromino.col + col) * grid, (tetromino.row + row) * grid, grid - 1, grid - 1);
            }
          }
        }
      }
    }

    // listen to keyboard events to move the active tetromino
    document.addEventListener('keydown', function (e) {
      if (gameOver) return;

      // left and right arrow keys (move)
      if (e.which === 37 || e.which === 39) {
        const col = e.which === 37
          ? tetromino.col - 1
          : tetromino.col + 1;

        if (isValidMove(tetromino.matrix, tetromino.row, col)) {
          tetromino.col = col;
        }
      }

      // up arrow key (rotate)
      if (e.which === 38) {
        const matrix = rotate(tetromino.matrix);
        if (isValidMove(matrix, tetromino.row, tetromino.col)) {
          tetromino.matrix = matrix;
        }
      }

      // down arrow key (drop)
      if (e.which === 40) {
        const row = tetromino.row + 1;

        if (!isValidMove(tetromino.matrix, row, tetromino.col)) {
          tetromino.row = row - 1;

          placeTetromino();
          return;
        }

        tetromino.row = row;
      }
    });

    // start the game
    rAF = requestAnimationFrame(loop);
  </script>
</body>